﻿# -*- coding: utf-8 -*-
#------------------------------------------------------------
# pelisalacarta - XBMC Plugin
# Canal para filmenoi
# http://blog.tvalacarta.info/plugin-xbmc/pelisalacarta/
#------------------------------------------------------------
import urlparse,urllib2,urllib,re
import os, sys

from core import logger
from core import config
from core import scrapertools
from core.item import Item
from servers import servertools

__channel__ = "filmenoi"
__category__ = "F,S"
__type__ = "generic"
__title__ = "Filme-noi.com"
__language__ = "ES"
__creationdate__ = "20131223"

DEBUG = config.get_setting("debug")

def isGeneric():
    return True

def mainlist(item):
    logger.info("[filmenoi.py] mainlist")
    item.url="http://www.filmeonline2013.biz";
    return novedades(item)

def novedades(item):
    logger.info("[filmenoi.py] novedades")
    itemlist = []
	
    # Descarga la página
    data = scrapertools.cache_page(item.url)
    data = re.sub(r"\n|\r|\t|\s{2}|&nbsp;","",data)
	
    
    
    patron = '<!--end #post-->.*?'
    patron += 'href="([^"]+)" '
    patron += 'title="(.*?)".*?'
    patron += '<img.*?src="([^"]+)"'

    matches = re.compile(patron,re.DOTALL).findall(data)
    
    for scrapedurl, scrapedtitle, scrapedthumbnail in matches:
        thumbnail = scrapertools.find_single_match(scrapedthumbnail,"(http\://http://www.filmeonline2013.biz/wp-content/uploads/.*?.jpg)")
        scrapedplot = ""
        #if (DEBUG): logger.info("title=["+scrapedtitle+"], url=["+scrapedurl+"], thumbnail=["+scrapedthumbnail+"]")
        if (DEBUG): logger.info("url=["+scrapedurl+"], thumbnail=["+scrapedthumbnail+"], title=["+scrapedtitle+"]") # Falla en sacar las imagenes por que tienen espacios
        itemlist.append( Item(channel=__channel__, action="findvideos", title=scrapedtitle , url=scrapedurl , thumbnail=scrapedthumbnail , plot=scrapedplot , folder=True) )
    
    
    
    # Extrae el paginador
    try:
        next_page = scrapertools.get_match(data,"<span class='current'>\d+</span><a href='([^']+)' class='page larger'>\d+</a>")
        itemlist.append( Item(channel=__channel__, title=">> Página siguiente", url=next_page, action="novedades" , folder=True) )
    except: pass



    return itemlist

def findvideos(item):
    logger.info("[filmenoi.py] findvideos")
    data = scrapertools.cache_page(item.url)
    data = re.sub(r"\n|\r|\t|\s{2}|&nbsp;","",data)
    itemlist=[]
    
    
    #trailer
    patron = '<iframe.*? src="([^"]+)".*?>'
    
    # Busca los enlaces a los videos
    listavideos = servertools.findvideos(data)
    
    for video in listavideos:
        videotitle = scrapertools.unescape(video[0])
        url = video[1]
        server = video[2]
        plot = scrapertools.get_match(data,'title=".*?" rel="category tag">.*?</a><p>([^<]+)</p>')
        #xbmctools.addnewvideo( __channel__ , "play" , category , server ,  , url , thumbnail , plot )
        itemlist.append( Item(channel=__channel__, action="play", server=server, title=item.title + videotitle  , url=url , thumbnail=item.thumbnail , plot=plot , fulltitle = item.title , folder=False) )
    return itemlist


 
# Verificación automática de canales: Esta función debe devolver "True" si está ok el canal.
def test():
    # mainlist
    novedades_items = mainlist(Item())
    # Da por bueno el canal si alguno de los vídeos de "Novedades" devuelve mirrors
    bien = False
    for singleitem in novedades_items:
        mirrors_items = findvideos( item=singleitem )
        for mirror_item in mirrors_items:
            video_items = play(mirror_item)
            if len(video_items)>0:
                return True

    return False
